program rybka;

const   MAXM=1000;
        MAXN=1000;
        INFTY=3000000;

type    PPole=^TPole;
        TPole=record
                x,y:longint;
                halda:longint;
                t:longint;
                c:longint;
                zpole,dopole:PPole;
        end;

var     m,n,x1,y1,x2,y2,t1,t2:longint;           { zadan parametry }
        rybnik:array[1..MAXM,1..MAXN] of TPole;  { pole rybnka }
        halda:array[1..MAXM*MAXN] of PPole;      { halda v poli }
        velhaldy:longint;

procedure prehod(pos1:longint; pos2:longint);    { peho v hald dv pole }
var tmp:PPole;
begin
        halda[pos1]^.halda:=pos2;
        halda[pos2]^.halda:=pos1;
        tmp:=halda[pos1];
        halda[pos1]:=halda[pos2];
        halda[pos2]:=tmp;
end;

procedure upravhaldu(var pole:TPole);		 { sni hodnotu c(x,y) pole v hald }
var     hpos:longint;
begin
        hpos:=pole.halda;
        while (hpos>1) and (halda[hpos]^.c < halda[hpos div 2]^.c) do begin
                prehod(hpos,hpos div 2);
                hpos:=hpos div 2;
        end;
end;

function vyberzhaldy:PPole;                      { vyber z haldy pole s nejnim c(x,y) }
var     hpos,minpos:longint;
        hotovo:boolean;
begin
        if velhaldy=0 then
                vyberzhaldy:=nil
        else begin
                vyberzhaldy:=halda[1];
                halda[1]:=halda[velhaldy];
		halda[1]^.halda:=1;
                dec(velhaldy);
                hotovo:=false;
                hpos:=1;
                repeat
                        { bu u jsme na spodku haldy }
                        if (hpos*2>velhaldy) then hotovo:=true
                        { nebo mme jen jednoho potomka }
                        else if (hpos*2=velhaldy) then begin
                                hotovo:=true;
                                if (halda[hpos]^.c>halda[hpos*2]^.c) then
                                        prehod(hpos,hpos*2);
                        end
                        { nebo mme dva potomky }
                        else begin
                                minpos:=hpos;
                                if (halda[minpos]^.c>halda[hpos*2]^.c) then
                                        minpos:=hpos*2;
                                if (halda[minpos]^.c>halda[hpos*2+1]^.c) then
                                        minpos:=hpos*2+1;
                                if (minpos=hpos) then
                                        hotovo:=true
                                else begin
                                        prehod(hpos,minpos);
                                        hpos:=minpos;
                                end;
                        end;
                until hotovo;
        end;
end;

procedure vypis(var f:text; var start:TPole);
var minule,pole:PPole;
begin
	minule:=nil;
	pole:=@start;
        while pole^.zpole<>nil do begin
		pole^.dopole:=minule;
		minule:=pole;
		pole:=pole^.zpole;
	end;
	pole:=minule;
	while pole<>nil do begin
		if pole^.c-pole^.zpole^.c>1 then write(f,pole^.c-pole^.zpole^.c-1,' ');
                if pole^.x>pole^.zpole^.x then write(f,'V ');
                if pole^.x<pole^.zpole^.x then write(f,'Z ');
                if pole^.y>pole^.zpole^.y then write(f,'J ');
                if pole^.y<pole^.zpole^.y then write(f,'S ');
		pole:=pole^.dopole;
        end;
end;

procedure vylepsipole(var ktere:TPole; var odkud:TPole);
var cek:longint;
begin
        { jak dlouho musm pokat, ne se pole dost oheje? }
        cek:=t1-(odkud.c+ktere.t);
        if cek<0 then cek:=0;
	{ jedn se o clov pole? pokud ano, vbec neekej }
	if (ktere.x=x2) and (ktere.y=y2) then begin
		ktere.c:=odkud.c+1;
		ktere.zpole:=@odkud;
		upravhaldu(ktere);
	end
        { kdy pokm tolik, bude to ok na tomto i clovm poli? je to lep cesta?}
        else if (odkud.c+cek+odkud.t<=t2) and (odkud.c+cek+ktere.t+1<=t2)
             and (ktere.c>odkud.c+cek+1) then begin
                ktere.c:=odkud.c+cek+1;
                ktere.zpole:=@odkud;
                upravhaldu(ktere);
        end;
end;

var     min:PPole;
        hotovo:boolean;
        f1,f2:text;
        i,j:longint;
begin
        assign(f1,'rybka.in');
        reset(f1);
        assign(f2,'rybka.out');
        rewrite(f2);
        readln(f1,m,n,t1,t2);
        readln(f1,x1,y1,x2,y2);
        for j:=1 to n do
                for i:=1 to m do begin
                        read(f1,rybnik[i,j].t);
                        rybnik[i,j].x:=i;
                        rybnik[i,j].y:=j;
                        rybnik[i,j].c:=INFTY;
                        rybnik[i,j].zpole:=nil;
                        rybnik[i,j].halda:=velhaldy+1;
                        halda[velhaldy+1]:=@rybnik[i,j];
                        inc(velhaldy);
                end;
        rybnik[x1,y1].c:=0;
        upravhaldu(rybnik[x1,y1]);

        { hlavn smyka vbru z haldy }
        hotovo:=false;
        repeat
                min:=vyberzhaldy;
                { bu u v hald nic k pidn nen }
                if (min=nil) or (min^.c=INFTY) then begin
                        writeln(f2,'Chudak Julka!');
                        hotovo:=true;
                end
                { nebo vybrm clov pole }
                else if (min^.x=x2) and (min^.y=y2) then begin
                        hotovo:=true;
        	        vypis(f2,rybnik[x2,y2]);
                        { A ije Julka! }
                end
                { nebo je to njak obecn pole }
                else begin
                        if min^.x>1 then vylepsipole(rybnik[min^.x-1,min^.y],min^);
                        if min^.y>1 then vylepsipole(rybnik[min^.x,min^.y-1],min^);
                        if min^.x<M then vylepsipole(rybnik[min^.x+1,min^.y],min^);
                        if min^.y<N then vylepsipole(rybnik[min^.x,min^.y+1],min^);
                end;
        until hotovo;
	close(f1);
	close(f2);
end.
